/*
 * Security Context Mapping Protocol Daemon
 *
 * Debugging support.
 *
 * Copyright (c) 2001-2002 James Morris <jmorris@intercode.com.au>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 */
#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <stdarg.h>
#include <errno.h>
#include <string.h>
#include <syslog.h>
#include <linux/flask/flask_types.h>
#include <linux/flask/flnetlink.h>

#include "server.h"
#include "debug.h"

void debug(char *fmt, ...)
{
	if (debugging) {
		va_list args;
		
		va_start(args, fmt);
		vsyslog(LOG_DEBUG, fmt, args);
		va_end(args);
	}
	
	return;
}
